"use strict";
/**
 * index.ts
 * Copyright (C) 2020 Editora Sanar
 *
 * Distributed under terms of the MIT license.
 * @author Edgard Leal <edgard.leal@sanar.com>
 * @module index.ts
 */
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
exports.__esModule = true;
exports.actionDeleteField = exports.shuffleList = void 0;
/**
 * Return a range sort for a givem list
 */
function shuffleList(params) {
    var copy = __spreadArrays(params);
    var result = [];
    while (copy.length) {
        var index = Math.round(Math.random() * copy.length);
        var value = copy[index];
        copy.splice(index, 1);
        result.push(value);
    }
    return result;
}
exports.shuffleList = shuffleList;
/**
 * Delete a field from given object
 */
function actionDeleteField(fieldName, obj) {
    delete obj[fieldName]; // eslint-disable-line
    return obj;
}
exports.actionDeleteField = actionDeleteField;
var ACTIONS = {};
ACTIONS["delete"] = actionDeleteField;
/**
 * Random delte half of object properties
 */
function thanos(param, action) {
    if (action === void 0) { action = 'delete'; }
    var keys = Object.keys(param);
    var halfCount = Math.round(keys.length / 2);
    var shuffledFields = shuffleList(keys).splice(halfCount, halfCount + 1);
    var actionFunction = ACTIONS[action];
    for (var i = 0; i < shuffledFields.length; i += 1) {
        var item = shuffledFields[i];
        actionFunction(item, param);
    }
    var remainingFields = Object.keys(param);
    for (var i = 0; i < remainingFields.length; i += 1) {
        var field = remainingFields[i];
        if (typeof param[field] === 'object') {
            thanos(param[field]);
        }
    }
    return param;
}
exports["default"] = thanos;
